<?php

/**
 * SHA512Pass Class
 *
 * @package SHA512-Pass
 * @version 1.1 / WordPress SHA-512-Pass [Dovecot Compatible]
 * @since PHP verson 5.5
 */
 
#
# THIS FILE HAS BEEN MODIFIED FOR PHP 5.5 AND LATER, USING PHP'S BUILT-IN
# SHA HASHING.  THIS IS DESIGNED TO PRODUCE DOVECOT-COMPATIBLE SECURE
# PASSWORDS, WHERE BCRYPT IS NOT AVAILABLE AT THE QUERY SOURCE.
#
# This is based upon the Solar Designer's Openwall Portable PHP Hash
# functions (userland).
#
# I'm with Solar.  There's absolutely no warranty.

class SHA512Pass {
	var $portable_hashes;
	var $random_state;
	
	/**
	 * PHP5 constructor.
	 */
	
	
	function gensalt_sha512_crypt($input)
	{
		# The initial salt, $output, sets the algorithm and rounds,
        # then a psueudo-random function appends a base64_encoded
        # string to the salt.  As such, the resulting hash will be
        # different any time the same password is encrypted.
		#
		# The rounds statement is used to preserve compatbility
		# between authentication sources (Sun, etc.).
				
		$output = '$6$rounds=';
		$min=5000;
		$max=9999;
		$output .= rand($min,$max);
		$output .= '$';
		$output .= substr(str_replace('+','.',base64_encode(md5(mt_rand(), true))),0,16);
		return $output;
	}


	function Pass2Hash($password)
	{
		if ( strlen( $password ) > 64 ) {
			return '*';
		}

		$random = '';
		$hash = crypt($password, $this->gensalt_sha512_crypt($random));
		if (strlen($hash) == 118) {
				return $hash;
		}
	}
}
